# include	<stdio.h>
# include	<stdlib.h>
# include	<ctype.h>
# include	<string.h>

static char **config = NULL;

void
load_config(const char *pathname)
{
    FILE *src;
    char *line;
    size_t linelen;
    unsigned int cnt;

    if ((src = fopen(pathname, "rt")) == NULL)
        return;

    line = NULL;
    linelen = 0;
    config = malloc(sizeof(char *));
    config[0] = NULL;
    cnt = 0;

    while (getline(&line, &linelen, src) != -1)
    {
	char *name, *value;
	char *lp, *end, *tmp;
	size_t len;

        for (lp = &line[strlen(line)]; lp > line && isspace(lp[-1]); lp--)
	    ;
	*lp = '\0';
	for (lp = line; *lp != '\0' && isspace(*lp); lp++)
	    ;

	// lp now points at a non-space character and the last character
	// in line is also a non-space character

	if (*lp == '\0'	// empty line
	 || *lp == '#'	// comment
	 || *lp == '=')	// badness!
	    continue;	// ignore

	// find '='
        for (end = &lp[1]; *end != '\0' && *end != '='; end++)
	    ;
	if (*end == '\0')
	    continue;	// badness

	tmp = end;	// point at '='
	while (end > lp && isspace(end[-1]))
	    end--;
	len = end - lp;

	name = malloc(len + 1);
	memcpy(name, lp, len);
	name[len] = '\0';

	// start just after '='
	for (lp = &tmp[1]; *lp != '\0' && isspace(*lp); lp++)
	    ;
	if (*lp == '\0')
	{
	    free(name);
	    continue;
	}

	value = strdup(lp);	// line is terminated by a non-space

	config = realloc(config, ((cnt+1)*2+1) * sizeof(char *));
	config[cnt*2] = name;
	config[cnt*2+1] = value;
	cnt++;
	config[cnt*2] = NULL;
    	free(line);
	line = 0;
	linelen = 0;
    }

    if (line != NULL)
        free(line);
    fclose(src);

    return;
}

char *
find_config(char *name)
{
    int i;

    if (config == NULL)
        return NULL;
    for (i = 0; config[i] != NULL; i += 2)
        if (strcmp(config[i], name) == 0)
	    break;

    return (config[i] != NULL) ? config[i+1] : NULL;
}

void
free_config()
{
    int i;

    if (config == NULL)
        return;
    for (i = 0; config[i] != NULL; i += 2)
    {
        free(config[i]);
	free(config[i+1]);
    }
    free(config);
    config = NULL;
}
